//
//  PSPWSyncManager.h
//  PSPWare
//
//  Created by Maksim Rogov on Sun Mar 06 2005.
//  Copyright (c) 2005 Nullriver, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "PSPWSyncContacts.h"
#import "PSPWSyncMusic.h"
#import "PSPWSyncPhotos.h"
#import "PSPWSyncMovies.h"
#import "PSPWSyncBackup.h"
#import "PSPWSyncBookmarks.h"
#import "PSPWSyncJukebox.h"


// Inbound notifications
#define PSPWCancelSyncNotification									@"PSPWCancelSyncNotification"
#define PSPWCancelSyncEstimateNotification							@"PSPWCancelSyncEstimateNotification"

@interface PSPWSyncManager : NSObject {
	id							delegate;

	NSString			*		pspVolume;
	BOOL						pspIsMounted;
	BOOL						pspIsUnmounting;
	BOOL						isSyncing;
	BOOL						shouldCancelSync;
	BOOL						isIndeterminate;
	unsigned	long	long	syncBytesTotal;
	unsigned	long	long	syncBytes;
	unsigned	long	long	syncBytesEstimate;
	
}

// Accessors
- (id)delegate;
- (void)setDelegate:(id)theDelegate;
- (void)setPSPVolume:(NSString *)pspVolumePath;
- (NSString *)pspVolume;
- (NSString *)pspName;
- (void)setPSPIsMounted:(BOOL)isMounted;
- (BOOL)pspIsMounted;
- (void)setPSPIsUnmounting:(BOOL)isUnmounting ;
- (BOOL)pspIsUnmounting;
- (BOOL)canSync;
- (BOOL)canCancelSync;
- (BOOL)isSyncing;
- (void)setIsSyncing:(BOOL)yorn;
- (BOOL)shouldCancelSync;
- (void)setShouldCancelSync:(BOOL)cancelSync;
- (BOOL)isIndeterminate;
- (void)setIsIndeterminate:(BOOL)yorn;
- (unsigned long long)syncBytesTotal;
- (unsigned long long)syncBytes;
- (unsigned long long)syncBytesEstimate;
- (unsigned int)syncPercentEstimate;

// Methods
- (BOOL)isFirstSync;
- (void)detectPSP;
- (void)setIcon;
- (NSNumber *)pspSpace;
- (NSNumber *)pspFreeSpace;
- (NSNumber *)pspUsedSpace;
- (void)refreshSyncBytesEstimate;
- (void)_refreshSyncBytesEstimate;
- (void)sync;
- (void)_sync;
- (void)cancelSync;
- (void)eject;
- (void)syncWasCancelled;

@end
